import { Dispatch, Reducer, ReducerAction, ReducerState } from 'react';
export interface MiddlewareAPI<S, A> {
    dispatch: Dispatch<A>;
    getState(): S;
}
export declare type Middleware<S, A> = (api: MiddlewareAPI<S, A>) => DispatchAction<A>;
export declare function useReducerWithMiddleware<R extends Reducer<any, any>>(reducer: Reducer<ReducerState<R>, ReducerAction<R>>, initialState: ReducerState<R>): ApplyMiddleware<R>;
declare type DispatchAction<A> = (next: Dispatch<A>) => (action: A) => void;
declare type ApplyMiddleware<R extends Reducer<any, any>> = (middlewares: Array<Middleware<ReducerState<R>, ReducerAction<R>>>) => {
    store: ReducerState<R>;
    dispatch: Dispatch<ReducerAction<R>>;
};
export {};
